#include <afxwin.h>
#include <afxext.h>

class CGetBtripDlg : public CDialog {
public:
    char DName[MAXTITLELEN];
    CBusinesTrip *PBusinesTrip;
    CEdit e1, e2, e3, p1;
    CComboBox DvsnList, CityList, TargetList, PlaceList, TrainsList, StatList;
    char UDateString[MAXDATELEN];
    char PDateString[MAXDATELEN];
    DivisionList *Home, *End;

    CGetBtripDlg(UINT Idd);
    ~CGetBtripDlg();
    BOOL OnInitDialog();
    void OnOK();
    void DoDataExchange( CDataExchange* pDX);

private:
    void DoFillBuffer();
    BOOL ValidNames();
    BOOL ValidDates();
};

class CSwitchDlg : public CDialog {
public:
    char DName[MAXTITLELEN];
    DivisionList *Home, *End;
    CListBox SwitchList;

    CSwitchDlg(UINT Idd);
    ~CSwitchDlg();
    BOOL OnInitDialog();
    void DoDataExchange( CDataExchange* pDX );
    afx_msg void AddItem();
    afx_msg void DeleteItem();
    afx_msg void ListAction();
    DECLARE_MESSAGE_MAP()
};

class CUpdateDlg : public CDialog {
public:
    CListBox UpdateList;
    char *DlgDBFileName;
    char *DlgTitle;

    CUpdateDlg(UINT Idd, char *DBFileName, char *DTitle = NULL);
    ~CUpdateDlg() { delete DlgDBFileName; delete DlgTitle; };
    BOOL OnInitDialog();
    void DoDataExchange( CDataExchange* pDX );
    afx_msg void AddItem();
    afx_msg void DeleteItem();
    afx_msg void ListAction();
    DECLARE_MESSAGE_MAP()
};

class CSearchDlg : public CDialog {
public:
    char DName[MAXTITLELEN];
    BtripList *Home;
    CListBox ViewList;
    AttrType Type;
    long Division;
    unsigned Code;
    struct SearchKey Key, KeyBuf;
    Exchange *PExchangeData;

    CSearchDlg(UINT Idd, Exchange *PData);
    ~CSearchDlg();
    BOOL OnInitDialog();
    void OnOK();
    void DoDataExchange( CDataExchange* pDX );

private:
    int KeyComp();
};

class CGeneralViewDlg : public CDialog {
public:
    char DName[MAXTITLELEN];
    CListBox ViewList;
    ViewType VType;
    long Division;

    CGeneralViewDlg(UINT Idd, ViewType Type, long Dvsn = 0);
    BOOL OnInitDialog();
    void DoDataExchange( CDataExchange* pDX );
};

class CAttributeDlg : public CDialog {
public:
    char DName[MAXTITLELEN];
    CComboBox DvsnList;
//    TGroupBox _FAR * KeyGroup, * SearchGroup;
    CButton KeyGroup, SearchGroup;
    CButton Initials, Dvsns, IsAccount, IsPrep, IsPerson;
    DivisionList *Home;
    Exchange *PExchangeData;

    CAttributeDlg(UINT Idd, Exchange *PData);
    ~CAttributeDlg();
    BOOL OnInitDialog();
    void OnOK();
    void DoDataExchange( CDataExchange* pDX );
    afx_msg void ForInitials();
    afx_msg void ForDvsns();
    afx_msg void Account();
    afx_msg void Prepayment();
    afx_msg void Person();
    DECLARE_MESSAGE_MAP()
};

class CSelectDlg : public CDialog {
public:
    char DName[MAXTITLELEN];
    DivisionList *Home;
    CListBox SwitchList;
    Exchange *PExchangeData;

    CSelectDlg(UINT Idd, Exchange *PData);
    ~CSelectDlg();
    BOOL OnInitDialog();
    void OnOK();
    void DoDataExchange( CDataExchange* pDX );
    afx_msg void ListAction();
    DECLARE_MESSAGE_MAP()
};

class CCodeDlg : public CDialog {
public:
    char DName[MAXTITLELEN];
    char DPrompt[MAXTITLELEN];
    CEdit code;

    CCodeDlg(UINT Idd, LPSTR ATitle, LPSTR APrompt);
    BOOL OnInitDialog();
    void OnOK();
    void DoDataExchange( CDataExchange* pDX );
};
