#include <windows.h>
#include <dos.h>
#include <mem.h>
#include <string.h>

#ifdef __WATCOMC__
#include <i86.h>
#endif

/*
#ifdef __WATCOMC__
#pragma aux WBRQSHELLINIT export
#pragma aux BTRCALL export
#pragma aux WBTRVSTOP export
#endif
*/

#define BTR_INT     0x7B                    /* Btrieve interrupt vector */
#define BTR_OFFSET  0x33               /* Btrieve offset within segment */
#define VARIABLE_ID 0x6176     /* id for variable length records - 'va' */

#define POS_LEN           128   /* Position Block = FCB + Position */
#define SERVICE_BLOCK 386       /* 128(Position Block) + 256(Key) + 2(Status) */
#define STAT_OFS   384  /* offset of Status in service block */
#define FCB_OFS    0     /* offset of FCB in service block  */
#define CUR_OFS    38    /* offset of Position in service block  */
#define KEY_OFS    128   /* offset of Key in service block  */
#define DATA_OFFSET   0     /* offset of Data in data block  */

WORD  wParamSel;
WORD  wParamSeg;
WORD  wServiceSel;
WORD  wServiceSeg;
WORD  wDataSel;
WORD  wDataSeg;
char far *XData;
char far *XService;
DWORD dMem;

struct DPMIParam
{
  DWORD EDI;
  DWORD ESI;
  DWORD EBP;
  DWORD RESERVED;
  DWORD EBX;
  DWORD EDX;
  DWORD ECX;
  DWORD EAX;
  WORD FLAGS;
  WORD ES;
  WORD DS;
  WORD FS;
  WORD GS;
  WORD IP;
  WORD CS;
  WORD SP;
  WORD SS;
} XDPMI;

struct BTRIEVE_PARMS      /* structure passed to Btrieve Record Manager */
{
  unsigned BUF_OFFSET;                    /* callers data buffer offset */
  unsigned BUF_SEG;                      /* callers data buffer segment */
  int      BUF_LEN;                            /* length of data buffer */
  unsigned CUR_OFFSET;                    /* user position block offset */
  unsigned CUR_SEG;                      /* user position block segment */
  unsigned FCB_OFFSET;                            /* offset of disk FCB */
  unsigned FCB_SEG;                              /* segment of disk FCB */
  int      FUNCTION;                              /* requested function */
  unsigned KEY_OFFSET;                   /* offset of user's key buffer */
  unsigned KEY_SEG;                     /* segment of user's key buffer */
  char     KEY_LENGTH;                   /* length of user's key buffer */
  char     KEY_NUMBER;                  /* key of reference for request */
  unsigned STAT_OFFSET;                        /* offset of status word */
  unsigned STAT_SEG;                          /* segment of status word */
  int      XFACE_ID;                             /* language identifier */
} far *XParam;

typedef struct BTRIEVE_PARMS far *pBTRIEVE_PARMS;

static WORD wOffset;

#ifdef __WATCOMC__
extern void CallInt();
#pragma aux CallInt = \
        "mov ax,ds"     \
        "mov es,ax"     \
        "mov di,wOffset"\
        "mov bl,7Bh"    \
        "xor bh,bh"     \
        "mov ax,300h"   \
        "mov cx,0"      \
        "int 31h"       \
        modify  [ax dx es di bx cx];
#endif

#ifdef __WATCOMC__
int FAR PASCAL __export WBRQSHELLINIT( HINSTANCE hInst, unsigned RecordLeng)
#else
int WINAPI WBRQSHELLINIT( HINSTANCE hInst, unsigned RecordLeng)
#endif
{
//  HGLOBAL hMem;

  dMem = GlobalDosAlloc( sizeof(struct BTRIEVE_PARMS)); /* allocate dos memory for Record Manager */
  if(dMem == NULL)
         return 1; /* Error */
  wParamSel = LOWORD (dMem);
  wParamSeg = HIWORD (dMem);
  XParam = (pBTRIEVE_PARMS) MAKELONG( 0, wParamSel);//((DWORD) wParamSel << 16);
  /*
  hMem = LOWORD(GlobalHandle(wParamSel));
  hMem = GlobalReAlloc( hMem, 0, GMEM_MODIFY | GMEM_DDESHARE);
  */
  dMem = GlobalDosAlloc(SERVICE_BLOCK);        /* allocate dos memory for service block */
  if(dMem == NULL)
         return 1; /* Error */
  wServiceSel = LOWORD (dMem);
  wServiceSeg = HIWORD (dMem);
  XService = (char far *) MAKELONG( 0, wServiceSel);//((DWORD) wServiceSel << 16);
  /*
  hMem = LOWORD(GlobalHandle(wServiceSel));
  hMem = GlobalReAlloc( hMem, 0, GMEM_MODIFY | GMEM_DDESHARE);
  */
  return 0; /* Success */
}

#ifdef __WATCOMC__
int FAR PASCAL __export WBTRVSTOP( void)
#else
int WINAPI WBTRVSTOP( void)
#endif
{
  GlobalDosFree (wParamSel);
  GlobalDosFree (wServiceSel);
  return 0;
}

#ifdef __WATCOMC__
int FAR PASCAL __export  BTRCALL ( int  OP, char far *POS_BLK, char far *DATA_BUF,
                          int far *DATA_LEN, char far *KEY_BUF, int KEY_LEN,
                          int KEY_NUM)
#else
int WINAPI BTRCALL ( int  OP, char far *POS_BLK, char far *DATA_BUF,
                          int far *DATA_LEN, char far *KEY_BUF, int KEY_LEN,
                          int KEY_NUM)
#endif
{
  static int Status = 0;
//  WORD wSegment = FP_SEG((void far *) &XDPMI);
//  HGLOBAL hMem;

  wOffset = LOWORD((char far *) &XDPMI);//FP_OFF((void far *) &XDPMI);
//  memset((void far *) &XDPMI, 0, sizeof(struct DPMIParam));
  XDPMI.EDI = 0;
  XDPMI.ESI = 0;
  XDPMI.EBP = 0;
  XDPMI.RESERVED = 0;
  XDPMI.EBX = 0;
  XDPMI.EDX = 0;
  XDPMI.ECX = 0;
  XDPMI.EAX = 0;
  XDPMI.FLAGS = 0;
  XDPMI.ES = 0;
  XDPMI.DS = 0;
  XDPMI.FS = 0;
  XDPMI.GS = 0;
  XDPMI.IP = 0;
  XDPMI.CS = 0;
  XDPMI.SP = 0;
  XDPMI.SS = 0;
  XDPMI.DS = wParamSeg;
  if(DATA_LEN != NULL) {
         dMem = GlobalDosAlloc(*DATA_LEN); /* allocate dos memory for Data record */
         if(dMem == NULL)
                return 19; /* UNRECOVERABLE_ERROR */
         wDataSel = LOWORD (dMem);
         wDataSeg = HIWORD (dMem);
         XData = (char far *) MAKELONG( 0, wDataSel);//((DWORD) wDataSel << 16);
         /*
         hMem = LOWORD(GlobalHandle(wDataSel));
         hMem = GlobalReAlloc( hMem, 0, GMEM_MODIFY | GMEM_DDESHARE);
         */
         _fmemcpy( XData, DATA_BUF, *DATA_LEN);
         XParam->BUF_LEN          = *DATA_LEN;
  }
  else {
         wDataSel = 0;
         wDataSeg = 0;
  }

  if(POS_BLK != NULL)
         _fmemcpy((char far *) XService + FCB_OFS,(char far *) POS_BLK, POS_LEN);
  if(KEY_BUF != NULL)
         _fmemcpy((char far *)  XService + KEY_OFS,(char far *) KEY_BUF, KEY_LEN);
  XParam->STAT_SEG = XParam->FCB_SEG = XParam->CUR_SEG = XParam->KEY_SEG = wServiceSeg;
  XParam->FUNCTION       = OP;
  XParam->STAT_OFFSET = STAT_OFS;
  XParam->FCB_OFFSET  = FCB_OFS;
  XParam->CUR_OFFSET  = CUR_OFS;
  XParam->BUF_OFFSET  = DATA_OFFSET;
  XParam->BUF_SEG        = wDataSeg;
  XParam->KEY_OFFSET  = KEY_OFS;
  XParam->KEY_LENGTH  = 255;             /* use max since we don't know */
  XParam->KEY_NUMBER  = KEY_NUM;
  XParam->XFACE_ID       = VARIABLE_ID;
#ifdef __WATCOMC__
        CallInt();
#endif
#ifdef __BORLANDC__
/*
  _asm{
                mov     ds, wParamSeg
                xor     dx, dx
                int     78h
  }
*/
  _asm{
                mov ax,ds
                mov es,ax
//              mov es,wSegment
                mov di,wOffset
                mov bl,BTR_INT
                xor bh,bh
                mov ax,300h
                mov cx,0
                int 31h
  }
#endif
  if(DATA_LEN != NULL)
         *DATA_LEN = XParam->BUF_LEN;
  if(DATA_BUF != NULL && DATA_LEN != NULL)
         _fmemcpy((char far *) DATA_BUF,(char far *) XData, *DATA_LEN);
  if(POS_BLK != NULL)
         _fmemcpy((char far *) POS_BLK,(char far *) XService + FCB_OFS, POS_LEN);
  if(KEY_BUF != NULL)
         _fmemcpy((char far *) KEY_BUF,(char far *) XService + KEY_OFS, KEY_LEN);
  Status = *((int far *)(XService + STAT_OFS));
  if(wDataSel != 0)
         GlobalDosFree(wDataSel); /* free dos memory for Data record */
  return Status;
}

#ifdef __WATCOMC__
BOOL FAR PASCAL LibMain( HANDLE hInstance, WORD wDataSegment,
                         WORD wHeapSize, LPSTR lpszCmdLine )
{
        return TRUE;
}
#endif
