#define MAXNAMELEN 20
#define MAXSTRLEN 30
#define MAXSLEN 8
#define MAXDATELEN 12
#define MAXIDLEN 6
#define MAXDNAMELEN 80
#define MAXTITLELEN 80

#define EM_INITERROR 10
#define EM_SETUPERROR 20

typedef enum { All, Debtors} ViewType;
typedef enum { Accnt, Prpmnt, Prsn, None} AttrType;

struct SearchKey {
  char Names[3][MAXNAMELEN];
  unsigned char Sign;
};

struct Exchange {
  AttrType Type;
  char Names[3][MAXNAMELEN];
  long Division;
  unsigned Code;
};

struct Date {
    unsigned char Day;
    unsigned char Month;
    unsigned int Year;
};

struct Division
{
  long Code;        	        /*   */
  char Name[MAXDNAMELEN];       /*  */
};

struct DivisionList
{
  Division Item;
  DivisionList *Next;
};

struct BtripList
{
  unsigned BtripCode;
  int InListIndex;
  BtripList *Next;
};

struct CBusinesTrip
{
  unsigned Code;           /*  */
  char Name[MAXNAMELEN];   /*  */
  char ForName[MAXNAMELEN];/*  */
  char SubName[MAXNAMELEN];/*  */
  long Division;           /*  */
  char City[MAXSTRLEN];    /*  */
  char Target[MAXSTRLEN];  /*  */
  char Place[MAXSTRLEN];   /*  */
  Date UDate;              /*     */
  Date PDate;              /*     */
  Date FUDate;             /*    */
  Date FPDate;             /*    */
  char Trains[MAXSTRLEN];  /*  */
  char States[MAXSTRLEN];  /*   */
  unsigned long SMoney;    /*   */
  char PNumber[MAXSTRLEN]; /*   */
  unsigned char IsAccount; /*    - */
  unsigned char IsDebt;    /*  ,   .- */
  Date ADate;              /*    */
  Date PrDate;             /*     */
  unsigned long PrMoney;   /*   */
  unsigned char IsPrep;    /*    */
  unsigned char Reserved;  /* */
};

struct Register
{
  char Name[MAXNAMELEN];   /*  */
  char ForName[MAXNAMELEN];/*  */
  char SubName[MAXNAMELEN];/*  */
  long Division;       	   /*  */
  unsigned long RestDebit; /*   . */
  unsigned long RestCredit;/*   . */
  Date AcDate;             /*    */
  unsigned long AcMoney;   /*   */
  Date RetDate;            /*   */
  unsigned long RetMoney;  /*   */
};
